/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package io.confluent.ksql.version.metrics;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

/** Represents basic metrics captured on a single ksql component */
@org.apache.avro.specific.AvroGenerated
public class KsqlVersionMetrics extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 441145512006693662L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"KsqlVersionMetrics\",\"namespace\":\"io.confluent.ksql.version.metrics\",\"doc\":\"Represents basic metrics captured on a single ksql component\",\"fields\":[{\"name\":\"timestamp\",\"type\":\"long\",\"doc\":\"Time when this data record was created on the ksql component (Unix time).\"},{\"name\":\"confluentPlatformVersion\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"doc\":\"The version of the Confluent Platform this ksql component is running.\"},{\"name\":\"ksqlComponentType\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"Identifies the ksql component\"},{\"name\":\"isActive\",\"type\":\"boolean\",\"doc\":\"Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.\"}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<KsqlVersionMetrics> ENCODER =
      new BinaryMessageEncoder<KsqlVersionMetrics>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<KsqlVersionMetrics> DECODER =
      new BinaryMessageDecoder<KsqlVersionMetrics>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<KsqlVersionMetrics> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<KsqlVersionMetrics> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<KsqlVersionMetrics> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<KsqlVersionMetrics>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this KsqlVersionMetrics to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a KsqlVersionMetrics from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a KsqlVersionMetrics instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static KsqlVersionMetrics fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  /** Time when this data record was created on the ksql component (Unix time). */
   private long timestamp;
  /** The version of the Confluent Platform this ksql component is running. */
   private java.lang.String confluentPlatformVersion;
  /** Identifies the ksql component */
   private java.lang.String ksqlComponentType;
  /** Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query. */
   private boolean isActive;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public KsqlVersionMetrics() {}

  /**
   * All-args constructor.
   * @param timestamp Time when this data record was created on the ksql component (Unix time).
   * @param confluentPlatformVersion The version of the Confluent Platform this ksql component is running.
   * @param ksqlComponentType Identifies the ksql component
   * @param isActive Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
   */
  public KsqlVersionMetrics(java.lang.Long timestamp, java.lang.String confluentPlatformVersion, java.lang.String ksqlComponentType, java.lang.Boolean isActive) {
    this.timestamp = timestamp;
    this.confluentPlatformVersion = confluentPlatformVersion;
    this.ksqlComponentType = ksqlComponentType;
    this.isActive = isActive;
  }

  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return timestamp;
    case 1: return confluentPlatformVersion;
    case 2: return ksqlComponentType;
    case 3: return isActive;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: timestamp = (java.lang.Long)value$; break;
    case 1: confluentPlatformVersion = value$ != null ? value$.toString() : null; break;
    case 2: ksqlComponentType = value$ != null ? value$.toString() : null; break;
    case 3: isActive = (java.lang.Boolean)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'timestamp' field.
   * @return Time when this data record was created on the ksql component (Unix time).
   */
  public long getTimestamp() {
    return timestamp;
  }


  /**
   * Sets the value of the 'timestamp' field.
   * Time when this data record was created on the ksql component (Unix time).
   * @param value the value to set.
   */
  public void setTimestamp(long value) {
    this.timestamp = value;
  }

  /**
   * Gets the value of the 'confluentPlatformVersion' field.
   * @return The version of the Confluent Platform this ksql component is running.
   */
  public java.lang.String getConfluentPlatformVersion() {
    return confluentPlatformVersion;
  }


  /**
   * Sets the value of the 'confluentPlatformVersion' field.
   * The version of the Confluent Platform this ksql component is running.
   * @param value the value to set.
   */
  public void setConfluentPlatformVersion(java.lang.String value) {
    this.confluentPlatformVersion = value;
  }

  /**
   * Gets the value of the 'ksqlComponentType' field.
   * @return Identifies the ksql component
   */
  public java.lang.String getKsqlComponentType() {
    return ksqlComponentType;
  }


  /**
   * Sets the value of the 'ksqlComponentType' field.
   * Identifies the ksql component
   * @param value the value to set.
   */
  public void setKsqlComponentType(java.lang.String value) {
    this.ksqlComponentType = value;
  }

  /**
   * Gets the value of the 'isActive' field.
   * @return Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
   */
  public boolean getIsActive() {
    return isActive;
  }


  /**
   * Sets the value of the 'isActive' field.
   * Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
   * @param value the value to set.
   */
  public void setIsActive(boolean value) {
    this.isActive = value;
  }

  /**
   * Creates a new KsqlVersionMetrics RecordBuilder.
   * @return A new KsqlVersionMetrics RecordBuilder
   */
  public static io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder newBuilder() {
    return new io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder();
  }

  /**
   * Creates a new KsqlVersionMetrics RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new KsqlVersionMetrics RecordBuilder
   */
  public static io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder newBuilder(io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder other) {
    if (other == null) {
      return new io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder();
    } else {
      return new io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder(other);
    }
  }

  /**
   * Creates a new KsqlVersionMetrics RecordBuilder by copying an existing KsqlVersionMetrics instance.
   * @param other The existing instance to copy.
   * @return A new KsqlVersionMetrics RecordBuilder
   */
  public static io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder newBuilder(io.confluent.ksql.version.metrics.KsqlVersionMetrics other) {
    if (other == null) {
      return new io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder();
    } else {
      return new io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder(other);
    }
  }

  /**
   * RecordBuilder for KsqlVersionMetrics instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<KsqlVersionMetrics>
    implements org.apache.avro.data.RecordBuilder<KsqlVersionMetrics> {

    /** Time when this data record was created on the ksql component (Unix time). */
    private long timestamp;
    /** The version of the Confluent Platform this ksql component is running. */
    private java.lang.String confluentPlatformVersion;
    /** Identifies the ksql component */
    private java.lang.String ksqlComponentType;
    /** Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query. */
    private boolean isActive;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[0].schema(), other.timestamp);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.confluentPlatformVersion)) {
        this.confluentPlatformVersion = data().deepCopy(fields()[1].schema(), other.confluentPlatformVersion);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.ksqlComponentType)) {
        this.ksqlComponentType = data().deepCopy(fields()[2].schema(), other.ksqlComponentType);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.isActive)) {
        this.isActive = data().deepCopy(fields()[3].schema(), other.isActive);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
    }

    /**
     * Creates a Builder by copying an existing KsqlVersionMetrics instance
     * @param other The existing instance to copy.
     */
    private Builder(io.confluent.ksql.version.metrics.KsqlVersionMetrics other) {
      super(SCHEMA$);
      if (isValidValue(fields()[0], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[0].schema(), other.timestamp);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.confluentPlatformVersion)) {
        this.confluentPlatformVersion = data().deepCopy(fields()[1].schema(), other.confluentPlatformVersion);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.ksqlComponentType)) {
        this.ksqlComponentType = data().deepCopy(fields()[2].schema(), other.ksqlComponentType);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.isActive)) {
        this.isActive = data().deepCopy(fields()[3].schema(), other.isActive);
        fieldSetFlags()[3] = true;
      }
    }

    /**
      * Gets the value of the 'timestamp' field.
      * Time when this data record was created on the ksql component (Unix time).
      * @return The value.
      */
    public long getTimestamp() {
      return timestamp;
    }


    /**
      * Sets the value of the 'timestamp' field.
      * Time when this data record was created on the ksql component (Unix time).
      * @param value The value of 'timestamp'.
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder setTimestamp(long value) {
      validate(fields()[0], value);
      this.timestamp = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'timestamp' field has been set.
      * Time when this data record was created on the ksql component (Unix time).
      * @return True if the 'timestamp' field has been set, false otherwise.
      */
    public boolean hasTimestamp() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'timestamp' field.
      * Time when this data record was created on the ksql component (Unix time).
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder clearTimestamp() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'confluentPlatformVersion' field.
      * The version of the Confluent Platform this ksql component is running.
      * @return The value.
      */
    public java.lang.String getConfluentPlatformVersion() {
      return confluentPlatformVersion;
    }


    /**
      * Sets the value of the 'confluentPlatformVersion' field.
      * The version of the Confluent Platform this ksql component is running.
      * @param value The value of 'confluentPlatformVersion'.
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder setConfluentPlatformVersion(java.lang.String value) {
      validate(fields()[1], value);
      this.confluentPlatformVersion = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'confluentPlatformVersion' field has been set.
      * The version of the Confluent Platform this ksql component is running.
      * @return True if the 'confluentPlatformVersion' field has been set, false otherwise.
      */
    public boolean hasConfluentPlatformVersion() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'confluentPlatformVersion' field.
      * The version of the Confluent Platform this ksql component is running.
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder clearConfluentPlatformVersion() {
      confluentPlatformVersion = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'ksqlComponentType' field.
      * Identifies the ksql component
      * @return The value.
      */
    public java.lang.String getKsqlComponentType() {
      return ksqlComponentType;
    }


    /**
      * Sets the value of the 'ksqlComponentType' field.
      * Identifies the ksql component
      * @param value The value of 'ksqlComponentType'.
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder setKsqlComponentType(java.lang.String value) {
      validate(fields()[2], value);
      this.ksqlComponentType = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'ksqlComponentType' field has been set.
      * Identifies the ksql component
      * @return True if the 'ksqlComponentType' field has been set, false otherwise.
      */
    public boolean hasKsqlComponentType() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'ksqlComponentType' field.
      * Identifies the ksql component
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder clearKsqlComponentType() {
      ksqlComponentType = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'isActive' field.
      * Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
      * @return The value.
      */
    public boolean getIsActive() {
      return isActive;
    }


    /**
      * Sets the value of the 'isActive' field.
      * Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
      * @param value The value of 'isActive'.
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder setIsActive(boolean value) {
      validate(fields()[3], value);
      this.isActive = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'isActive' field has been set.
      * Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
      * @return True if the 'isActive' field has been set, false otherwise.
      */
    public boolean hasIsActive() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'isActive' field.
      * Indicates if the server was active in the last 24 hours. A server is considered active if it received a rest request or it has at least one running query.
      * @return This builder.
      */
    public io.confluent.ksql.version.metrics.KsqlVersionMetrics.Builder clearIsActive() {
      fieldSetFlags()[3] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public KsqlVersionMetrics build() {
      try {
        KsqlVersionMetrics record = new KsqlVersionMetrics();
        record.timestamp = fieldSetFlags()[0] ? this.timestamp : (java.lang.Long) defaultValue(fields()[0]);
        record.confluentPlatformVersion = fieldSetFlags()[1] ? this.confluentPlatformVersion : (java.lang.String) defaultValue(fields()[1]);
        record.ksqlComponentType = fieldSetFlags()[2] ? this.ksqlComponentType : (java.lang.String) defaultValue(fields()[2]);
        record.isActive = fieldSetFlags()[3] ? this.isActive : (java.lang.Boolean) defaultValue(fields()[3]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<KsqlVersionMetrics>
    WRITER$ = (org.apache.avro.io.DatumWriter<KsqlVersionMetrics>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<KsqlVersionMetrics>
    READER$ = (org.apache.avro.io.DatumReader<KsqlVersionMetrics>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

  @Override protected boolean hasCustomCoders() { return true; }

  @Override public void customEncode(org.apache.avro.io.Encoder out)
    throws java.io.IOException
  {
    out.writeLong(this.timestamp);

    if (this.confluentPlatformVersion == null) {
      out.writeIndex(0);
      out.writeNull();
    } else {
      out.writeIndex(1);
      out.writeString(this.confluentPlatformVersion);
    }

    out.writeString(this.ksqlComponentType);

    out.writeBoolean(this.isActive);

  }

  @Override public void customDecode(org.apache.avro.io.ResolvingDecoder in)
    throws java.io.IOException
  {
    org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
    if (fieldOrder == null) {
      this.timestamp = in.readLong();

      if (in.readIndex() != 1) {
        in.readNull();
        this.confluentPlatformVersion = null;
      } else {
        this.confluentPlatformVersion = in.readString();
      }

      this.ksqlComponentType = in.readString();

      this.isActive = in.readBoolean();

    } else {
      for (int i = 0; i < 4; i++) {
        switch (fieldOrder[i].pos()) {
        case 0:
          this.timestamp = in.readLong();
          break;

        case 1:
          if (in.readIndex() != 1) {
            in.readNull();
            this.confluentPlatformVersion = null;
          } else {
            this.confluentPlatformVersion = in.readString();
          }
          break;

        case 2:
          this.ksqlComponentType = in.readString();
          break;

        case 3:
          this.isActive = in.readBoolean();
          break;

        default:
          throw new java.io.IOException("Corrupt ResolvingDecoder.");
        }
      }
    }
  }
}










